/****************************************************************************
**
** SPDX-License-Identifier: BSD-2-Clause-Patent
**
** SPDX-FileCopyrightText: Copyright (c) 2023 SoftAtHome
**
** Redistribution and use in source and binary forms, with or without modification,
** are permitted provided that the following conditions are met:
**
** 1. Redistributions of source code must retain the above copyright notice,
** this list of conditions and the following disclaimer.
**
** 2. Redistributions in binary form must reproduce the above copyright notice,
** this list of conditions and the following disclaimer in the documentation
** and/or other materials provided with the distribution.
**
** Subject to the terms and conditions of this license, each copyright holder
** and contributor hereby grants to those receiving rights under this license
** a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable
** (except for failure to satisfy the conditions of this license) patent license
** to make, have made, use, offer to sell, sell, import, and otherwise transfer
** this software, where such license applies only to those patent claims, already
** acquired or hereafter acquired, licensable by such copyright holder or contributor
** that are necessarily infringed by:
**
** (a) their Contribution(s) (the licensed copyrights of copyright holders and
** non-copyrightable additions of contributors, in source or binary form) alone;
** or
**
** (b) combination of their Contribution(s) with the work of authorship to which
** such Contribution(s) was added by such copyright holder or contributor, if,
** at the time the Contribution is added, such addition causes such combination
** to be necessarily infringed. The patent license shall not apply to any other
** combinations which include the Contribution.
**
** Except as expressly stated above, no rights or licenses from any copyright
** holder or contributor is granted under this license, whether expressly, by
** implication, estoppel or otherwise.
**
** DISCLAIMER
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
** AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
** IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
** ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE
** LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
** DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
** SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
** CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
** OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
** USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**
****************************************************************************/

#if !defined(__CTHULHU_DEFINES_H__)
#define __CTHULHU_DEFINES_H__

#ifdef __cplusplus
extern "C"
{
#endif

#define ALIAS "Alias"
#define CTHULHU "Cthulhu"
#define CTHULHU_CONTAINER "Container"
#define CTHULHU_CONTAINERS CTHULHU_CONTAINER // deprecated
#define CTHULHU_INSTANCES "Instances"
#define CTHULHU_SANDBOX "Sandbox"
#define CTHULHU_EXECENV CTHULHU_SANDBOX // deprecated
#define CTHULHU_EE CTHULHU_INSTANCES    // deprecated
#define CTHULHU_CONFIG "Config"
#define CTHULHU_CONFIG_DEFAULTBACKEND "DefaultBackend"
#define CTHULHU_CONFIG_USEOVERLAYFS "UseOverlayFS"
#define CTHULHU_CONFIG_USEBUNDLES "UseBundles"
#define CTHULHU_CONFIG_BUNDLE_LOCATION "BundleLocation"
#define CTHULHU_CONFIG_IMAGE_LOCATION "ImageLocation"
#define CTHULHU_CONFIG_BLOB_LOCATION "BlobLocation"
#define CTHULHU_CONFIG_STORAGE_LOCATION "StorageLocation"
#define CTHULHU_CONFIG_PLUGIN_LOCATION "PluginLocation"
#define CTHULHU_CONFIG_GRACEFUL_SHUTDOWN_TIMEOUT "GracefulShutdownTimeoutSeconds"
#define CTHULHU_CONFIG_DEBUG "Debug"
#define CTHULHU_CONFIG_DEBUG_DEFAULTKEEPOVERLAYFSMOUNTED "DefaultKeepOverlayfsMounted"
#define CTHULHU_CONFIG_UNPRIVCAPABILITIES "UnprivCapabilities"
#define CTHULHU_CONFIG_HOSTOBJECTSMOUNTOPTIONS "HostObjectsMountOptions"
#define CTHULHU_CONFIG_HOSTOBJECTSMOUNTOPTIONSTMPFS "HostObjectsMountOptionsTmpfs"

#define CTHULHU_INFO "Information"
#define CTHULHU_PLUGINS "Plugins"
#define CTHULHU_PLUGINS_PRIVATE "PluginsPrivate"
#define CTHULHU_ONBOARDING_FILE "OnboardingFile"
#define CTHULHU_ONBOARDING_LOCATION "OnboardingLocation"
#define CTHULHU_NETWORKCONFIG "NetworkConfig"

#define MOD_CTHULHU "mod_cthulhu"

#define CTHULHU_DM CTHULHU
#define CTHULHU_DM_CONTAINER CTHULHU_DM "." CTHULHU_CONTAINER
#define CTHULHU_DM_CONTAINER_INSTANCES CTHULHU_DM_CONTAINER "." CTHULHU_INSTANCES
#define CTHULHU_DM_CONTAINERS CTHULHU_DM_CONTAINER_INSTANCES // deprecated

#define CTHULHU_DM_SANDBOX CTHULHU_DM "." CTHULHU_SANDBOX
#define CTHULHU_DM_SANDBOX_INSTANCES CTHULHU_DM_SANDBOX "." CTHULHU_INSTANCES
#define CTHULHU_DM_EXECENV CTHULHU_DM_SANDBOX      // deprecated
#define CTHULHU_DM_EE CTHULHU_DM_SANDBOX_INSTANCES // deprecated

#define CTHULHU_DM_CONFIG CTHULHU_DM "." CTHULHU_CONFIG

#define CTHULHU_DM_INFO CTHULHU_DM "." CTHULHU_INFO
#define CTHULHU_DM_NETWORKCONFIG CTHULHU_DM "." CTHULHU_PLUGINS_PRIVATE "." CTHULHU_NETWORKCONFIG

#define CTHULHU_INFO_VERSION "Version"
#define CTHULHU_INFO_BACKENDVERSION "BackendVersion"
#define CTHULHU_INFO_BACKENDNAME "BackendName"
#define CTHULHU_INFO_OVERLAYFSONCREATE "OverlayFSOnCreate"
#define CTHULHU_INFO_BUNDLES_SUPPORTED "BundlesSupported"
#define CTHULHU_INFO_ODLLOADED "odlLoaded"
#define CTHULHU_INFO_INITIALIZED "Initialized"

#define AMXM_SELF "self"
#define CTHULHU_MOD_BACKEND "cthulhu-backend"
#define CTHULHU_MOD_BACKEND_COMMAND "backend-command"
#define CTHULHU_MOD_BACKEND_COMMAND_EXECUTE "backend-command-execute"
#define CTHULHU_MOD_BACKEND_COMMAND_EXECUTE_PARAMS_COMMAND "command"
#define CTHULHU_MOD_BACKEND_COMMAND_EXECUTE_PARAMS_ARGUMENTS "arguments"
#define CTHULHU_MOD_BACKEND_COMMAND_EXECUTE_PARAMS_TIMEOUT "timeout"

#define CTHULHU_CONTAINER_ID "ContainerId"
#define CTHULHU_CONTAINER_AUTOSTART "Autostart"
#define CTHULHU_CONTAINER_REMOVEDATA "RemoveData"
#define CTHULHU_CONTAINER_STATUS "Status"
#define CTHULHU_CONTAINER_BUNDLE "Bundle"
#define CTHULHU_CONTAINER_ALIAS ALIAS
#define CTHULHU_CONTAINER_BUNDLEVERSION "BundleVersion"
#define CTHULHU_CONTAINER_VENDOR "Vendor"
#define CTHULHU_CONTAINER_DESCRIPTION "Description"
#define CTHULHU_CONTAINER_SANDBOX "Sandbox"
#define CTHULHU_CONTAINER_PRIVATESANDBOX "PrivateSandbox"
#define CTHULHU_CONTAINER_CREATED "Created"
#define CTHULHU_CONTAINER_UPDATED "Updated"
#define CTHULHU_CONTAINER_OWNER "Owner"
#define CTHULHU_CONTAINER_PID "Pid"
#define CTHULHU_CONTAINER_ROOTFSISMOUNTED "RootfsIsMounted"
#define CTHULHU_CONTAINER_KEEPOVERLAYFSMOUNTED "KeepOverlayfsMounted"
#define CTHULHU_CONTAINER_AUTORESTART "AutoRestart"
#define CTHULHU_CONTAINER_LAYERS "Layers"
#define CTHULHU_CONTAINER_LAYERS_INDEX "Index"
#define CTHULHU_CONTAINER_LAYERS_LAYER "Layer"
#define CTHULHU_CONTAINER_LAYERS_MOUNTEDLAYER "MountedLayer"
#define CTHULHU_CONTAINER_RESOURCES "Resources"
#define CTHULHU_CONTAINER_RESOURCES_CPU "AllocatedCPUPercent"
#define CTHULHU_CONTAINER_RESOURCES_MEMORY "AllocatedMemory"
#define CTHULHU_CONTAINER_RESOURCES_DISKSPACE "AllocatedDiskSpace"
#define CTHULHU_CONTAINER_MOUNTS "Mounts"
#define CTHULHU_CONTAINER_MOUNTS_SOURCE "Source"
#define CTHULHU_CONTAINER_MOUNTS_DESTINATION "Destination"
#define CTHULHU_CONTAINER_MOUNTS_TYPE "Type"
#define CTHULHU_CONTAINER_MOUNTS_OPTIONS "Options"
#define CTHULHU_CONTAINER_DATA "Data"
#define CTHULHU_CONTAINER_DISKLOCATION "DiskLocation"
#define CTHULHU_CONTAINER_HOSTOBJECT "HostObject"
#define CTHULHU_CONTAINER_HOSTOBJECT_SOURCE "Source"
#define CTHULHU_CONTAINER_HOSTOBJECT_DESTINATION "Destination"
#define CTHULHU_CONTAINER_HOSTOBJECT_OPTIONS "Options"
#define CTHULHU_CONTAINER_LINKED_UUID "LinkedUUID"
#define CTHULHU_CONTAINER_INTERFACES "Interfaces"
#define CTHULHU_CONTAINER_INTERFACES_NAME "Name"
#define CTHULHU_CONTAINER_INTERFACES_ADDRESSES "Addresses"
#define CTHULHU_CONTAINER_INTERFACES_ADDRESSES_ADDRESS "Address"
#define CTHULHU_CONTAINER_MODULEVERSION "ModuleVersion"
#define CTHULHU_CONTAINER_ENVIRONMENTVARIABLES "EnvVariable"
#define CTHULHU_CONTAINER_ENVIRONMENTVARIABLES_KEY "Key"
#define CTHULHU_CONTAINER_ENVIRONMENTVARIABLES_VALUE "Value"
#define CTHULHU_CONTAINER_ENVIRONMENTVARIABLES_OCI "EnvVariableOCI"
#define CTHULHU_CONTAINER_ENVIRONMENTVARIABLES_OCI_KEY "Key"
#define CTHULHU_CONTAINER_ENVIRONMENTVARIABLES_OCI_VALUE "Value"
#define CTHULHU_CONTAINER_LASTREQSTATEACTIVE "LastReqStateActive"
#define CTHULHU_CONTAINER_REQUIRED_ROLES "RequiredRoles"
#define CTHULHU_CONTAINER_OPTIONAL_ROLES "OptionalRoles"
#define CTHULHU_CONTAINER_ASSIGNED_ROLES "AssignedRoles"
#define CTHULHU_CONTAINER_STARTTIME "StartTime"
#define CTHULHU_CONTAINER_UNPRIVILEGED "Unprivileged"
#define CTHULHU_CONTAINER_UNPRIVILEGED_PRIVILEGED "Privileged"
#define CTHULHU_CONTAINER_UNPRIVILEGED_ENABLED "Enabled"
#define CTHULHU_CONTAINER_UNPRIVILEGED_USERNAME "Username"
#define CTHULHU_CONTAINER_UNPRIVILEGED_UID "UID"
#define CTHULHU_CONTAINER_UNPRIVILEGED_GROUPNAME "Groupname"
#define CTHULHU_CONTAINER_UNPRIVILEGED_GID "GID"
#define CTHULHU_CONTAINER_UNPRIVILEGED_NUMREQUIREDUIDS "NumRequiredUIDs"
#define CTHULHU_CONTAINER_UNPRIVILEGED_UIDMAPPINGSTART "UidMappingStart"
#define CTHULHU_CONTAINER_UNPRIVILEGED_UIDMAPPINGRANGE "UidMappingRange"
#define CTHULHU_CONTAINER_UNPRIVILEGED_GIDMAPPINGSTART "GidMappingStart"
#define CTHULHU_CONTAINER_UNPRIVILEGED_GIDMAPPINGRANGE "GidMappingRange"
#define CTHULHU_CONTAINER_APPLICATIONDATA "ApplicationData"
#define CTHULHU_CONTAINER_APPLICATIONDATA_NAME "Name"
#define CTHULHU_CONTAINER_APPLICATIONDATA_CAPACITY "Capacity"
#define CTHULHU_CONTAINER_APPLICATIONDATA_ENCRYPTED "Encrypted"
#define CTHULHU_CONTAINER_APPLICATIONDATA_RETAIN "Retain"
#define CTHULHU_CONTAINER_APPLICATIONDATA_RETAIN_FOREVER "Forever"
#define CTHULHU_CONTAINER_APPLICATIONDATA_RETAIN_UNTILSTOPPED "UntilStopped"
#define CTHULHU_CONTAINER_APPLICATIONDATA_ACCESSPATH "AccessPath"

// named data structures for plugins
#define CTHULHU_CONTAINER_NETWORKCONFIG CTHULHU_NETWORKCONFIG

#define CTHULHU_DM_CONTAINER_ID            CTHULHU_CONTAINER_ID              // deprecated
#define CTHULHU_DM_CONTAINER_NAME          CTHULHU_CONTAINER_ID              // deprecated
#define CTHULHU_DM_CONTAINER_STATUS        CTHULHU_CONTAINER_STATUS          // deprecated
#define CTHULHU_DM_CONTAINER_BUNDLE        CTHULHU_CONTAINER_BUNDLE          // deprecated
#define CTHULHU_DM_CONTAINER_BUNDLEVERSION CTHULHU_CONTAINER_BUNDLEVERSION   // deprecated
#define CTHULHU_DM_CONTAINER_EE            CTHULHU_CONTAINER_SANDBOX         // deprecated
#define CTHULHU_DM_CONTAINER_CREATED       CTHULHU_CONTAINER_CREATED         // deprecated
#define CTHULHU_DM_CONTAINER_OWNER         CTHULHU_CONTAINER_OWNER           // deprecated
#define CTHULHU_DM_CONTAINER_PID           CTHULHU_CONTAINER_PID             // deprecated
#define CTHULHU_DM_CTR_CONTAINERID         CTHULHU_CONTAINER_ID              // deprecated
#define CTHULHU_DM_CONTAINER_AUTORESTART   CTHULHU_CONTAINER_AUTORESTART     // deprecated


#define CTHULHU_SANDBOX_ID "SandboxId"
#define CTHULHU_SANDBOX_ALIAS "Alias"
#define CTHULHU_SANDBOX_PARENT "Parent"
#define CTHULHU_SANDBOX_VERSION "Version"
#define CTHULHU_SANDBOX_VENDOR "Vendor"
#define CTHULHU_SANDBOX_ENABLE "Enable"
#define CTHULHU_SANDBOX_CREATED "Created"
#define CTHULHU_SANDBOX_DESCRIPTION CTHULHU_CONTAINER_DESCRIPTION
#define CTHULHU_SANDBOX_RESTART_REASON "RestartReason"
#define CTHULHU_SANDBOX_PID "Pid"
#define CTHULHU_SANDBOX_STATUS "Status"
#define CTHULHU_SANDBOX_CREATEDBYCONTAINER "CreatedByContainer"
#define CTHULHU_SANDBOX_CPU CTHULHU_CONTAINER_RESOURCES_CPU
#define CTHULHU_SANDBOX_MEMORY CTHULHU_CONTAINER_RESOURCES_MEMORY
#define CTHULHU_SANDBOX_DISKSPACE CTHULHU_CONTAINER_RESOURCES_DISKSPACE
#define CTHULHU_SANDBOX_AVAILABLE_ROLES "AvailableRoles"
#define CTHULHU_SANDBOX_AVAILABLE_ROLES_NAMES "AvailableRolesNames"
#define CTHULHU_SANDBOX_DEVICES "Devices"
#define CTHULHU_SANDBOX_DEVICES_DEVICE "Device"
#define CTHULHU_SANDBOX_DEVICES_PERMISSION "Permission"
#define CTHULHU_SANDBOX_DEVICES_TYPE "Type"
#define CTHULHU_SANDBOX_DEVICES_MAJOR "Major"
#define CTHULHU_SANDBOX_DEVICES_MINOR "Minor"
#define CTHULHU_SANDBOX_DEVICES_ACCESS "Access"
#define CTHULHU_SANDBOX_DEVICES_CREATE "Create"
#define CTHULHU_SANDBOX_UTS_NS "UtsNS"
#define CTHULHU_SANDBOX_UTS_NS_ENABLE "Enable"
#define CTHULHU_SANDBOX_UTS_NS_HOSTNAME "Hostname"
#define CTHULHU_SANDBOX_USER_NS "UserNS"
#define CTHULHU_SANDBOX_USER_NS_ENABLE "Enable"
#define CTHULHU_SANDBOX_USER_NS_MAPPINGS "Mappings"
#define CTHULHU_SANDBOX_USER_NS_MAPPINGS_MAPPING "Mapping"
#define CTHULHU_SANDBOX_NETWORK_NS "NetworkNS"
#define CTHULHU_SANDBOX_NETWORK_NS_ENABLE "Enable"
#define CTHULHU_SANDBOX_NETWORK_NS_TYPE "Type"
#define CTHULHU_SANDBOX_NETWORK_NS_TYPE_EMPTY "Empty"
#define CTHULHU_SANDBOX_NETWORK_NS_TYPE_VETH "Veth"
// no network namespace will be created in the sandbox, but the container will be notified to use
// the network namespace of the sandbox. This is more or less equivalent to lxc 'None'.
#define CTHULHU_SANDBOX_NETWORK_NS_TYPE_PARENTSB "ParentSandbox"
#define CTHULHU_SANDBOX_NETWORK_NS_INTERFACES "Interfaces"
#define CTHULHU_SANDBOX_NETWORK_NS_INTERFACES_INTERFACE "Interface"
#define CTHULHU_SANDBOX_NETWORK_NS_INTERFACES_BRIDGE "Bridge"
#define CTHULHU_SANDBOX_MOUNT_NS "MountNS"
#define CTHULHU_SANDBOX_MOUNT_NS_ENABLE "Enable"
#define CTHULHU_SANDBOX_MOUNT_NS_MOUNTS "Mounts"
#define CTHULHU_SANDBOX_MOUNT_NS_MOUNTS_HOST "Host"
#define CTHULHU_SANDBOX_MOUNT_NS_MOUNTS_TARGET "Target"
#define CTHULHU_SANDBOX_APPLICATIONDATA CTHULHU_CONTAINER_APPLICATIONDATA
#define CTHULHU_SANDBOX_APPLICATIONDATA_NAME CTHULHU_CONTAINER_APPLICATIONDATA_NAME
#define CTHULHU_SANDBOX_APPLICATIONDATA_CAPACITY CTHULHU_CONTAINER_APPLICATIONDATA_CAPACITY
#define CTHULHU_SANDBOX_APPLICATIONDATA_ENCRYPTED CTHULHU_CONTAINER_APPLICATIONDATA_ENCRYPTED
#define CTHULHU_SANDBOX_APPLICATIONDATA_RETAIN CTHULHU_CONTAINER_APPLICATIONDATA_RETAIN
#define CTHULHU_SANDBOX_APPLICATIONDATA_ACCESSPATH CTHULHU_CONTAINER_APPLICATIONDATA_ACCESSPATH
#define CTHULHU_SANDBOX_APPLICATIONDATA_APPLICATIONUUID "ApplicationUUID"
#define CTHULHU_SANDBOX_APPLICATIONDATA_UTILIZATION "Utilization"
#define CTHULHU_SANDBOX_APPLICATIONDATA_MOUNTPOINT "Mountpoint"

#define CTHULHU_ARG_FORCE "Force"

// stats are available on containers and sandboxes
#define CTHULHU_STATS "Stats"
#define CTHULHU_STATS_DISKSPACE "DiskSpace"
#define CTHULHU_STATS_MEMORY "Memory"
#define CTHULHU_STATS_ELEM_TOTAL "Total"
#define CTHULHU_STATS_ELEM_USED "Used"
#define CTHULHU_STATS_ELEM_FREE "Free"

#define CTHULHU_DM_CTR_AR_ENABLED "Enabled"
#define CTHULHU_DM_CTR_AR_RETRYCOUNT "RetryCount"
#define CTHULHU_DM_CTR_AR_RUNNINGSINCE "RunningSince"
#define CTHULHU_DM_CTR_AR_LASTRESTART "LastRestarted"
#define CTHULHU_DM_CTR_AR_NEXTRESTART "NextRestart"
#define CTHULHU_DM_CTR_AR_RESET "ResetPeriod"
#define CTHULHU_DM_CTR_AR_MAX_RETRYCOUNT "MaximumRetryCount"
#define CTHULHU_DM_CTR_AR_MIN_INT "RetryMinimumWaitInterval"
#define CTHULHU_DM_CTR_AR_MAX_INT "RetryMaximumWaitInterval"
#define CTHULHU_DM_CTR_AR_RETRY_INT "RetryIntervalMultiplier"
#define CTHULHU_DM_CTR_AR_ENABLE "Enable"

#define CTHULHU_NOTIF_COMMAND_ID "CommandID"
#define CTHULHU_NOTIF_CTR_ID "ContainerId"

// deprecated
#define CTHULHU_NOTIF_EE_ID CTHULHU_SANDBOX_ID

#define CTHULHU_NOTIF_ERROR_TYPE "type"
#define CTHULHU_NOTIF_ERROR_TYPESTR CTHULHU_NOTIF_ERROR_TYPE "str"

#define CTHULHU_NOTIF_REASON "reason"
#define CTHULHU_NOTIF_INFORMATION "information"

#define CTHULHU_NOTIF_CTR_CREATED "cthulhu:ctr:created"
#define CTHULHU_NOTIF_CTR_REMOVED "cthulhu:ctr:removed"
#define CTHULHU_NOTIF_CTR_UPDATED "cthulhu:ctr:updated"
#define CTHULHU_NOTIF_CTR_LIST "cthulhu:ctr:list"
#define CTHULHU_NOTIF_CTR_PS "cthulhu:ctr:ps"
#define CTHULHU_NOTIF_CTR_STATE "cthulhu:ctr:state"
#define CTHULHU_NOTIF_ERROR "cthulhu:error"
#define CTHULHU_NOTIF_SB_CREATED "cthulhu:sb:created"
#define CTHULHU_NOTIF_SB_UPDATED "cthulhu:sb:updated"
#define CTHULHU_NOTIF_SB_REMOVED "cthulhu:sb:removed"
#define CTHULHU_NOTIF_SB_LIST "cthulhu:sb:list"
#define CTHULHU_NOTIF_INITIALIZED "cthulhu:initialized"
#define CTHULHU_NOTIF_CTR_VALIDATED "cthulhu:ctr:validated"

#define CTHULHU_NOTIF_DM_OBJ_FULL "dm_obj"
#define CTHULHU_NOTIF_DM_OBJ_CHANGED "dm_changed"

// deprecated
#define CTHULHU_NOTIF_PARAMETERS CTHULHU_NOTIF_DM_OBJ_FULL

// deprecated
#define CTHULHU_NOTIF_EE_CREATED CTHULHU_NOTIF_SB_CREATED

#define CTHULHU_CMD_CTR_RM_PARAMKEY "paramKey"
#define CTHULHU_CMD_CTR_RM_PARAMVALUE "paramValue"

#define CTHULHU_CMD_LOADBACKEND "loadBackend"

#define CTHULHU_CMD_CTR_CREATE "create"
#define CTHULHU_CMD_CTR_REMOVE "remove"
#define CTHULHU_CMD_CTR_UPDATE "update"
#define CTHULHU_CMD_CTR_START "start"
#define CTHULHU_CMD_CTR_STOP "stop"
#define CTHULHU_CMD_CTR_RESTART "restart"
#define CTHULHU_CMD_CTR_LS "ls"
#define CTHULHU_CMD_CTR_MODIFY "modify"
#define CTHULHU_CMD_CTR_MODIFYNETWORKCONFIG "modifyNetworkConfig"
#define CTHULHU_CMD_CTR_EXECUTE "execute"
#define CTHULHU_CMD_CTR_EXECUTE_CMD "Cmd"
#define CTHULHU_CMD_CTR_EXECUTE_ARGUMENTS "Arguments"
#define CTHULHU_CMD_CTR_EXECUTE_TIMEOUT "Timeout"
#define CTHULHU_CMD_CTR_VALIDATE "validate"

#define CTHULHU_CMD_SB_CREATE "create"
#define CTHULHU_CMD_SB_START "start"
#define CTHULHU_CMD_SB_STOP "stop"
#define CTHULHU_CMD_SB_RESTART "restart"
#define CTHULHU_CMD_SB_REMOVE "remove"
#define CTHULHU_CMD_SB_MODIFY "modify"
#define CTHULHU_CMD_SB_LS "ls"
#define CTHULHU_CMD_SB_EXEC "exec"

#define CTHULHU_CMD_EE_CREATE CTHULHU_CMD_SB_CREATE  // deprecated
#define CTHULHU_CMD_EE_START  CTHULHU_CMD_SB_START   // deprecated
#define CTHULHU_CMD_EE_STOP   CTHULHU_CMD_SB_STOP    // deprecated
#define CTHULHU_CMD_EE_REMOVE CTHULHU_CMD_SB_REMOVE  // deprecated

#define CTHULHU_CMD_COMMAND "command"

#define CTHULHU_CONTAINER_START CTHULHU_CMD_CTR_START
#define CTHULHU_CONTAINER_STOP CTHULHU_CMD_CTR_STOP
#define CTHULHU_CONTAINER_RESTART CTHULHU_CMD_CTR_RESTART
#define CTHULHU_CONTAINER_CREATE CTHULHU_CMD_CTR_CREATE
#define CTHULHU_CONTAINER_REMOVE CTHULHU_CMD_CTR_REMOVE
#define CTHULHU_CONTAINER_LIST "list"

#define CTHULHU_BACKEND_CMD_INIT "init"
#define CTHULHU_BACKEND_CMD_CREATE "create"
#define CTHULHU_BACKEND_CMD_START "start"
#define CTHULHU_BACKEND_CMD_STOP "stop"
#define CTHULHU_BACKEND_CMD_REMOVE "remove"
#define CTHULHU_BACKEND_CMD_LIST "list"
#define CTHULHU_BACKEND_CMD_CTR_INFO "containerinfo"
#define CTHULHU_BACKEND_CMD_VERSION "version"
#define CTHULHU_BACKEND_CMD_INFORMATION "information"
#define CTHULHU_BACKEND_CMD_CTR_EXECUTE "execute"

#define CTHULHU_BACKEND_CMD_INIT_PARAM_PARSER "parser"
#define CTHULHU_BACKEND_CMD_INIT_PARAM_ROOTOBJECT "rootobject"

#define CTHULHU_BACKEND_NOTIF_CHANGED "cthulhu:backend:changed"
#define CTHULHU_BACKEND_NOTIF_CHANGED_DATA "data"

#define CTHULHU_COMMAND_PARAMETERS "Parameters"
#define CTHULHU_COMMAND_COMMAND "Command"
#define CTHULHU_COMMAND_COMMANDID "CommandID"

#define CTHULHU_CMD_CTR_LS_QUIET "Quiet"
#define CTHULHU_CMD_CTR_LOAD_PLUGIN "Plugin" // deprecated
#define CTHULHU_CMD_CTR_LOAD_BACKEND "Backend"

#define CTHULHU_CMD_SB_EXEC_CMD "Cmd"


#define CTHULHU_PLUGIN_START_CTRID "ContainerId"
#define CTHULHU_PLUGIN_START_DATA "Data"
#define CTHULHU_PLUGIN_START_SBDATA "SandboxData" // deprecated

#define CTHULHU_PLUGIN_STOP_DATA_TIMEOUT "Timeout"

#define CTHULHU_CONTAINER_STATUS_RUNNING "Running"
#define CTHULHU_CONTAINER_STATUS_STARTING "Starting"
#define CTHULHU_CONTAINER_STATUS_STOPPING "Stopping"
#define CTHULHU_CONTAINER_STATUS_RESTARTING "Restarting"
#define CTHULHU_CONTAINER_STATUS_ABORTING "Aborting"
#define CTHULHU_CONTAINER_STATUS_FREEZING "Freezing"
#define CTHULHU_CONTAINER_STATUS_THAWING "Thawing"
#define CTHULHU_CONTAINER_STATUS_UNKNOWN "Unknown"
#define CTHULHU_CONTAINER_STATUS_GHOST "Ghost"
#define CTHULHU_CONTAINER_STATUS_CREATED "Created"
#define CTHULHU_CONTAINER_STATUS_STOPPED "Stopped"
#define CTHULHU_CONTAINER_STATUS_FROZEN "Frozen"
#define CTHULHU_CONTAINER_STATUS_THAWED "Thawed"


#define TR_DEVICE "Device"
#define TR_DEVICE_DM TR_DEVICE_DM "."
#define TR_DEVICE_USERS "Users"
#define TR_DEVICE_USERS_DM TR_DEVICE_USERS "."
#define TR_DEVICE_USERS_USER "User"
#define TR_DEVICE_USERS_USER_DM TR_DEVICE_USERS_DM TR_DEVICE_USERS_USER "."
#define TR_DEVICE_USERS_ROLE "Role"
#define TR_DEVICE_USERS_ROLE_DM TR_DEVICE_USERS_DM TR_DEVICE_USERS_ROLE "."
#define TR_DEVICE_USERS_GROUP "Group"
#define TR_DEVICE_USERS_GROUP_DM TR_DEVICE_USERS_DM TR_DEVICE_USERS_GROUP "."
#define TR_DEVICE_USERS_ALIAS ALIAS
#define TR_DEVICE_USERS_GROUPNAME "Groupname"
#define TR_DEVICE_USERS_GROUPPARTICIPATION "GroupParticipation"
#define TR_DEVICE_USERS_ROLENAME "RoleName"
#define TR_DEVICE_USERS_ROLEPARTICIPATION "RoleParticipation"
#define TR_DEVICE_USERS_USERID "UserID"
#define TR_DEVICE_USERS_USERNAME "Username"
#define TR_DEVICE_USERS_ENABLE "Enable"

#define CTHULHU_MOD_BACKEND_EXEC "backend-execute"

#ifdef __cplusplus
}
#endif

#endif // __CTHULHU_DEFINES_H__
